
#define UL unsigned long int
#define TRYCOUNT	3

#include <stdio.h>
#include <windows.h>

#include "reservesortcore.cpp"
#include "mergesortcore.cpp"

double reservetotal[10];
double mergetotal[10];
UL datacount[10];
UL triedcount;

void result()
{
	UL i;

		printf("data count merge        | reserve\n");
	
	for(i=0;i<triedcount;i++)
	{
		printf(" %7d  %14.8f %14.8f\n"
		,datacount[i],mergetotal[i]/TRYCOUNT,reservetotal[i]/TRYCOUNT);
	}
	
	
}

UL CheckSort(UL *d,UL *e,UL count)
{
	//0 ... OK 1 ... NG
	UL i;
	for(i=0;i<(count-1);i++)
	{
		if ( (d[i]<d[i+1]) || ( (d[i]==d[i+1]) && (e[i]<e[i+1]) ) )
		{
		}else
		{
			return 1;
		}
		
	}
	return 0;
}

void MakeRandomize(UL *d,UL *e,UL count)
{
//
	UL i,sai;

	srand((unsigned)time(NULL));/* ǉ */

	for(i = 0; i < count; i++)
	{
		sai = rand() % RAND_MAX + 1;
		d[i]=sai;
		e[i]=i;
		if ( i % 10000 ==0 )
		{
//			printf("f[^Zbg %d\r",i);
		}
	}
	
}
void main()
{
	UL i,j,k;
	__int64 fr,t1,t2;
	double onetime;
	UL *d,*e;
	UL *od,*oe;
	
	datacount[0]=10000;
	for(i=1;i<8;i++)
	{
		datacount[i]=datacount[i-1]*2;
	}
	
	triedcount=0;
	
	i=0;
	while ( 1 )
	{
		d=(UL*)malloc(datacount[i]*sizeof(UL));
		e=(UL*)malloc(datacount[i]*sizeof(UL));
		od=(UL*)malloc(datacount[i]*sizeof(UL));
		oe=(UL*)malloc(datacount[i]*sizeof(UL));
		
		printf("merge sort\n");
		
		mergetotal[i]=0.0;
		reservetotal[i]=0.0;
		
		MakeRandomize(od,oe,datacount[i]);
		
		for(j=0;j<TRYCOUNT;j++)
		{
			for(k=0;k<datacount[i];k++)
			{
				d[k]=od[k];e[k]=oe[k];
			}
			QueryPerformanceFrequency((LARGE_INTEGER *)&fr);
			QueryPerformanceCounter((LARGE_INTEGER *)&t1);
			
			mergesorte(d,e,datacount[i]);
			
			QueryPerformanceCounter((LARGE_INTEGER *)&t2);
			onetime=(double)(t2-t1) / fr * 1000;
		
			printf("%f ",onetime);
			
			if ( CheckSort(d,e,datacount[i])==1 )
			{
				MessageBoxA(NULL,"merge\[gɎs܂","info",MB_OK);
			}
			
			mergetotal[i]+=onetime;
		}
		printf("\n");

		//reserve
		printf("reserve sort\n");
		
		for(j=0;j<TRYCOUNT;j++)
		{
			for(k=0;k<datacount[i];k++)
			{
				d[k]=od[k];e[k]=oe[k];
//				if (k%1000==0)
//				printf("f[^ %d %d\r",k,datacount[i]);
			}
			QueryPerformanceFrequency((LARGE_INTEGER *)&fr);
			QueryPerformanceCounter((LARGE_INTEGER *)&t1);
			
			reservesorte(d,e,datacount[i]);
			
			QueryPerformanceCounter((LARGE_INTEGER *)&t2);
			onetime=(double)(t2-t1) / fr * 1000;
		
			printf("%f ",onetime);
			if ( CheckSort(d,e,datacount[i])==1 )
			{
				MessageBoxA(NULL,"reserve\[gɎs܂","info",MB_OK);
			}
			reservetotal[i]+=onetime;
		}
		printf("\n");


		free(d);
		free(e);
		free(od);
		free(oe);
		
		triedcount++;
		result();
//		break;
//		printf("i:%f l:%f\n",mergetotal[i],reservetotal[i]);

		if ( reservetotal[i] > mergetotal[i] )
		{
			if ( (reservetotal[i] - mergetotal[i]) > 5*TRYCOUNT*1000 )
			{
				printf("õ\[gŁA5bȏ̍t܂\n");
				printf("PCł́Amerge\[g̕ł\n");
				break;
			}
		}
		if ( mergetotal[i] > reservetotal[i]  )
		{
			if ( (mergetotal[i] - reservetotal[i]) > 5*TRYCOUNT*1000 )
			{
				printf("õ\[gŁA5bȏ̍t܂\n");
				printf("PCł́Areserve\[g̕ł\n");
				break;
			}
		}
		i++;
		if (i==8) break;

	}
	
	if (i>7)
	{
		if ( reservetotal[9] > mergetotal[9] )
		{
			printf("PCł́Amerge\[g̕ł\n");
		}else
		{
			printf("PCł́Areserve\[g̕ł\n");
		}
	}
	
}
